//+------------------------------------------------------------------+
//|                                                      TFColor.mqh |
//|                              Copyright  2007, Troshenkin Andrey |
//|                                                 troshenkin@bk.ru |
//+------------------------------------------------------------------+
#import "TFColor.ex4"


//+------------------------------------------------------------------+
//        !!!!!!!!!!!!
//        TFColorConst.mqh
//+------------------------------------------------------------------+
/////////////////////   //////////////////////////////

int FIBO_IMPULS  =  1;
int FIBO_NORMAL  =  0;
int FIBO_CORRECT = -1;
int FIBO_TYPE_ERROR = -2;

int REAL_TF[] = {PERIOD_M1, PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1, PERIOD_MN1};
int ALL_TF[] = {PERIOD_M1, 2, PERIOD_M5, 10, PERIOD_M15, PERIOD_M30, PERIOD_H1, 120, PERIOD_H4, 480, PERIOD_D1, 2880, PERIOD_W1, 20160, PERIOD_MN1, 86400};

/////////////////////   //////////////////////////////

//      Print      PRINT_DEBUG
void PrintD(string sMessage);

// true     sName     ( )
bool IsObjectVisible(string sName);

// true        
bool IsTestingMode();

//         (   )
bool IsObjectSystem(string sName);

//    FIBO, TRENDLINE, TEXT
string GetLastObjectName();
int GetLastObjectNumber();

//  -: FIBO_IMPULS - , FIBO_NORMAL - , FIBO_CORRECT - , FIBO_TYPE_ERROR -    
int IsFiboImpuls(string sName);

//         ,    
string FindTrendLineForFiboByName(string sFiboName, bool& bUp[], double& nTLPeak[]);

//       
//color clColor -     
void SetObjectColor(color clColor);

//     PERIOD_M1, PERIOD_M5  ..
//int nTimeFrame -   (PERIOD_M1, PERIOD_M5  ..)
color GetColorByTF(int nTimeFrame);

//   
//color clColor -      
int GetTFByColor(color clColor);

//  ,   PERIOD_M1  "M1",  PERIOD_M5  "M5"  ..
//int nTimeFrame -   (PERIOD_M1, PERIOD_M5  ..)
string GetTFName(int nTimeFrame);

//     
//color clColor -       TF
string GetTFNameByColor(color clColor);

//   ( "_"     Text, Fibo, Trendline)
void RenameOldObjects();

//  :     
// arWindowSize   2 
bool GetStartEndBars(int& arWindowSize[]);

//      TEXT     (TRENDLINE)     -
//..        -
//double nFTop - OBJPROP_PRICE1  
//double nFBottom - OBJPROP_PRICE2  
//datetime dtFStart - OBJPROP_TIME1  
//datetime dtFEnd  - OBJPROP_TIME2  
//color clTFColor -   
//--------------
// :
//              (..  -    ), 
//       
//--------------
//      = clTFColor  OBJPROP_PRICE1  OBJPROP_PRICE2  nFTop, nFBottom, 
//   nFTop, nFBottom   , 
//   ,   TEXT    ,    -  , 
//       
// :
//dtFStart  dtFEnd     (TRENDLINE),   ,
//       dtFStart - dtFEnd
//    ,        
//..     5 ,    7 ,       5 - 9, .. 5 + (7-5)*2 = 9
//     (TEXT),             (TRENDLINE) 
string GetFiboWaveName(double nFTop, double nFBottom, datetime dtFStart, datetime dtFEnd, color clTFColor);



/////////////////////     //////////////////////////////

bool ON_SECOND_CLICK_SET_NEXT_TF();

//     ("..\scripts\ShowNames.mq4")
int LETTERS(string &arLetters[]);
string LETTERS_FONTFACE();
double LETTERS_WINDOW_LENGTH(); //      ( 0.1  1   ,  1 -    )


//  - ("..\scripts\SetImpuls.mq4", "..\scripts\SetCorrection.mq4")
int FIBO_LEVELS(double &arFiboLevels[]);
bool SHOW_FIBO_PRICE();
bool SHOW_FIBO_TF();
bool SHOW_FIBO_WAVE_NAME();
bool CORRECT_FIBO_DOUBLE_NAME();

int TRENDLINE_WIDTH();

//  "..\scripts\AddRectangle.mq4"
int RECT_WIDTH();

//  "..\scripts\DelCanceledFiboLevels.mq4"
int MAX_LEAVE_LEVELS();

//  "..\scripts\ClearGrafics.mq4"
int MEDIUM_DATED_TF();

//  #include "..\scripts\SaveFiboLevels.mq4"
string SAVE_FIBO_LEVELS_FILE_NAME();

//  ,   
color ColorM1();
color ColorM2();
color ColorM5();
color ColorM10();
color ColorM15();
color ColorM30();
color ColorH1();
color ColorH2();
color ColorH4();
color ColorH8();
color ColorD1();
color ColorD2();
color ColorW1();
color ColorW2();
color ColorMN1();
color ColorMN2();


//  "..\scripts\SetFontSize.mq4"
int FONT_SIZE1();
int FONT_SIZE2();

//  #include "..\scripts\CreateTFColors.mq4"
int COLORS_LEFT_POS();
int COLORS_TOP_POS();

/////////////////////     //////////////////////////////

string LETTERS_NAME();
string RECTANGLE_NAME();
string PIVOT_NAME();
string COLORS_NAME();