//+------------------------------------------------------------------+
//|                                                      TFColor.mq4 |
//|                              Copyright  2007, Troshenkin Andrey |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey"
#property link      "troshenkin@bk.ru"
#property library

#include <stdlib.mqh>
#include <TFColorConfig.mqh>

//+------------------------------------------------------------------+
//    
//+------------------------------------------------------------------+
string LETTERS_NAME() {return ("Letter_"); } //#include "..\scripts\Show Letters.mq4"
string RECTANGLE_NAME() {return ("Rectangle_"); } //#include "..\scripts\Add Rectangle.mq4"
string PIVOT_NAME() {return ("Arrow"); } //#include "..\scripts\Add Pivot.mq4"
string COLORS_NAME() {return ("Color_"); } //#include "..\scripts\Create TF Colors.mq4"

string PricePeriodAlarm_NAME = "PPA_"; //PricePeriodAlarm.mq4 
string vHandsTrade_NAME = "vHT_"; //vHandsTrade.mq4 
string vHandsTrade_Panel_NAME = "vHT_Panel"; //vHandsTrade.mq4 
//+------------------------------------------------------------------+


/////////////////////   //////////////////////////////
bool ON_SECOND_CLICK_SET_NEXT_TF() {return (ON_SECOND_CLICK_SET_NEXT_TF);}

int RECT_WIDTH() {return (RECT_WIDTH);}



int LETTERS(string &arLetters[]) 
{
   int nSize = ArraySize(LETTERS);
   ArrayResize(arLetters, nSize);
   ArrayCopy(arLetters, LETTERS, 0, 0, WHOLE_ARRAY);
   
   return (nSize);
}

string LETTERS_FONTFACE() {return (LETTERS_FONTFACE);}
double LETTERS_WINDOW_LENGTH() {return (LETTERS_WINDOW_LENGTH);}

int FIBO_LEVELS(double &arFiboLevels[]) 
{
   int nSize = ArraySize(FIBO_LEVELS);
   ArrayResize(arFiboLevels, nSize);
   ArrayCopy(arFiboLevels, FIBO_LEVELS, 0, 0, WHOLE_ARRAY);
   
   return (nSize);
}

bool SHOW_FIBO_PRICE() {return (SHOW_FIBO_PRICE);}
bool SHOW_FIBO_TF() {return (SHOW_FIBO_TF);}
bool SHOW_FIBO_WAVE_NAME() {return (SHOW_FIBO_WAVE_NAME);}
bool CORRECT_FIBO_DOUBLE_NAME() {return (CORRECT_FIBO_DOUBLE_NAME);}

int MAX_LEAVE_LEVELS() {return (MAX_LEAVE_LEVELS);}
int TRENDLINE_WIDTH() { return (TRENDLINE_WIDTH);}


int MEDIUM_DATED_TF() { return (MEDIUM_DATED_TF);}

string SAVE_FIBO_LEVELS_FILE_NAME() { return (SAVE_FIBO_LEVELS_FILE_NAME);}

color ColorM1() {return (ColorM1);}
color ColorM2() {return (ColorM2);}
color ColorM5() {return (ColorM5);}
color ColorM10() {return (ColorM10);}
color ColorM15() {return (ColorM15);}
color ColorM30() {return (ColorM30);}
color ColorH1() {return (ColorH1);}
color ColorH2() {return (ColorH2);}
color ColorH4() {return (ColorH4);}
color ColorH8() {return (ColorH8);}
color ColorD1() {return (ColorD1);}
color ColorD2() {return (ColorD2);}
color ColorW1() {return (ColorW1);}
color ColorW2() {return (ColorW2);}
color ColorMN1() {return (ColorMN1);}
color ColorMN2() {return (ColorMN2);}


int FONT_SIZE1() {return (FONT_SIZE1);}
int FONT_SIZE2() {return (FONT_SIZE2);}

int COLORS_LEFT_POS() {return (COLORS_LEFT_POS);}
int COLORS_TOP_POS() {return (COLORS_TOP_POS);}


/////////////////////   //////////////////////////////

void PrintD(string sMessage)
{
   if (PRINT_DEBUG)
      Print(sMessage);
}

bool IsTestingMode()
{
   bool bResult = IsTesting();
 
   //      WindowFirstVisibleBar, WindowBarsPerChart   
   if (!bResult)
      bResult = (ObjectFind(vHandsTrade_Panel_NAME) != -1);
      
   return (bResult);
}

bool IsObjectSystem(string sName)
{
   bool bIsSystem = false;
   
   if ( (StringSubstr(sName, 0, StringLen(LETTERS_NAME())) == LETTERS_NAME()) || 
         (StringSubstr(sName, 0, StringLen(COLORS_NAME())) == COLORS_NAME()) || 
         (StringSubstr(sName, 0, StringLen(PricePeriodAlarm_NAME)) == PricePeriodAlarm_NAME) || 
         (StringSubstr(sName, 0, StringLen(vHandsTrade_NAME)) == vHandsTrade_NAME) 
      )
      bIsSystem = true;
   
   return (bIsSystem);
}

bool GetStartEndBars(int& arWindowSize[])
{
   datetime dtFirstBar;
   int i, nStartBar, nEndBar;
   
   //     Time  Bars      , .. 0   
   if (!IsTestingMode())
   {
      nEndBar = WindowFirstVisibleBar();   
      if ( (WindowFirstVisibleBar() - WindowBarsPerChart()) > 0)
         nStartBar = WindowFirstVisibleBar() - WindowBarsPerChart();
      else
         nStartBar = 0;
   }
   else
   {
      dtFirstBar = ObjectGet(vHandsTrade_Panel_NAME, OBJPROP_TIME1);
      nStartBar = -1;
      for (i = 0; i < Bars; i++)
      {
         if (Time[i] <= dtFirstBar)
         {
            nStartBar = i + 4; //4   
            break;
         }
      }

      if (nStartBar != -1)
      {
         nEndBar = nStartBar + WindowFirstVisibleBar();
         if ( (nEndBar - nStartBar) > WindowBarsPerChart())
            nStartBar = nEndBar - WindowBarsPerChart();
      }
      else
         return (false);
   }
   
   arWindowSize[0] = nStartBar;
   arWindowSize[1] = nEndBar;
   
   PrintD("GetStartEndBars DateStart: " + TimeToStr(Time[nStartBar]) + ", DateEnd: " + TimeToStr(Time[nEndBar]));
   
   return (true);
}

bool IsObjectVisible(string sName)
{
   datetime dtWindowBarStart, dtWindowBarEnd;
   datetime dtStart, dtEnd;
   int nStartBar, nEndBar;
   int nWindowSize[2]; 
   bool bResult = false;

   if (ObjectFind(sName) !=-1)
   {
      if (!GetStartEndBars(nWindowSize))
         return (true);

      nStartBar = nWindowSize[0];
      nEndBar = nWindowSize[1];      
      dtWindowBarStart = Time[nEndBar];   
      dtWindowBarEnd = Time[nStartBar];   

      dtStart = ObjectGet(sName, OBJPROP_TIME1);   
      dtEnd = ObjectGet(sName, OBJPROP_TIME2);

      if ( (dtWindowBarStart > dtStart) || ((dtWindowBarStart > dtEnd) && (dtEnd > 0)) || 
                   ( (dtWindowBarEnd != Time[0]) && ((dtWindowBarEnd < dtStart) || (dtWindowBarEnd < dtEnd)) ) )
         bResult = false;      
      else
         bResult = true;

      PrintD("IsObjectVisible " + sName + " = " + bResult + " | " + TimeToStr(dtStart) + " " + TimeToStr(dtEnd) + " | " + TimeToStr(dtWindowBarStart) + " " + TimeToStr(dtWindowBarEnd));
   }
   
   return (bResult);
}

int IsFiboImpuls(string sName)
{
   int nType = -2;
   int i, nObjType, nFiboLevels;
   bool bIsCorrect, bIsImpuls;
   double nValue;
   
   //  ,     100%,    ,  
   //      100 - 
   nObjType = ObjectType(sName);
   if (nObjType == OBJ_FIBO)
   {
      bIsCorrect = false;
      bIsImpuls = false;
      nFiboLevels = ObjectGet( sName, OBJPROP_FIBOLEVELS );
      for(i=0; i < nFiboLevels; i++)
      {
         nValue = ObjectGet(sName, OBJPROP_FIRSTLEVEL + i);
         
         if ( nValue > 1)
            bIsImpuls = true;     
         else if ( (nValue < 1) && (nValue > 0) )
            bIsCorrect = true;     
      }

      if (bIsImpuls)
      {
         if (bIsCorrect)
            nType = 0;
         else
            nType = 1;
      }
      else
      {
         if (bIsCorrect)
            nType = -1;
      }
   }
   
   return (nType);
}

string GetLastObjectName()
{
   int obj_total=ObjectsTotal();
   int MaxNum, num, nSpaceIndex;
   string MaxName, name, sNewName, sTypeName;
   int nObjType;
   
   MaxNum = -1;
   MaxName = "";
   
   for(int i=0; i < obj_total; i++)
   {
      name = ObjectName(i);

      nObjType = ObjectType(name);
      if (!(nObjType == OBJ_TREND || nObjType == OBJ_TEXT || nObjType == OBJ_FIBO || nObjType == OBJ_ARROW))
         continue;

      if (nObjType == OBJ_ARROW)
      {
         if (ObjectGet(name, OBJPROP_ARROWCODE) != SYMBOL_RIGHTPRICE)
            continue;
      }

      nSpaceIndex = StringFind(name, " ", 1);
      if (nSpaceIndex < 0)
         continue;

      sTypeName = StringSubstr(name, 0, nSpaceIndex);
         
      if (!( (nObjType == OBJ_TREND && sTypeName == "Trendline") || (nObjType == OBJ_FIBO && sTypeName == "Fibo") 
               || (nObjType == OBJ_TEXT && sTypeName == "Text") || (nObjType == OBJ_ARROW && sTypeName == "Arrow") )
         )
         continue;

      num = StrToInteger(StringSubstr(name, nSpaceIndex + 1, StringLen(name) - nSpaceIndex));

      if (num == 0)
         continue;
         
      //     
      if (!IsObjectVisible(name)) 
         continue;

      if (num > MaxNum)
      {
         MaxNum = num;
         MaxName = name;
      }
   }

   return(MaxName);
}
//+------------------------------------------------------------------+

int GetLastObjectNumber()
{
   int obj_total=ObjectsTotal();
   int MaxNum, num, nSpaceIndex;
   string MaxName, name, sNewName, sTypeName;
   int nObjType;
   
   MaxNum = -1;
   
   for(int i=0; i < obj_total; i++)
   {
      name = ObjectName(i);

      nObjType = ObjectType(name);
      if (!(nObjType == OBJ_TREND || nObjType == OBJ_TEXT || nObjType == OBJ_FIBO || nObjType == OBJ_ARROW))
         continue;

      nSpaceIndex = StringFind(name, " ", 1);
      if (nSpaceIndex < 0)
         continue;

      nSpaceIndex = StringFind(name, " ", 1);
      if (nSpaceIndex < 0)
         continue;

      sTypeName = StringSubstr(name, 0, nSpaceIndex);
         
      if (!( (nObjType == OBJ_TREND && sTypeName == "Trendline") || (nObjType == OBJ_FIBO && sTypeName == "Fibo") 
               || (nObjType == OBJ_TEXT && sTypeName == "Text") || (nObjType == OBJ_ARROW && sTypeName == "Arrow") )
         )
         continue;

      num = StrToInteger(StringSubstr(name, nSpaceIndex + 1, StringLen(name) - nSpaceIndex));

      if (num == 0)
         continue;
         
      if (num > MaxNum)
      {
         MaxNum = num;
      }
   }

   return(MaxNum);
}

//+------------------------------------------------------------------+
void SetObjectColor(color clColor)
{
   string name = GetLastObjectName();
   if (name != "")
   {
      PrintD("Change color for: " + name);
      int nObjType = ObjectType(name);

      ObjectSet(name, OBJPROP_COLOR, clColor);

      if (nObjType == OBJ_FIBO)
         ObjectSet(name, OBJPROP_LEVELCOLOR, clColor);
      
      WindowRedraw();
   }
}

//+------------------------------------------------------------------+

int GetTFByColor(color clColor)
{
   int nPeriod = 0;
   
   if (clColor == ColorM1) nPeriod = PERIOD_M1;
   else if (clColor == ColorM2) nPeriod = 2;
   else if (clColor == ColorM5) nPeriod = PERIOD_M5;
   else if (clColor == ColorM10) nPeriod = 10;
   else if (clColor == ColorM15) nPeriod = PERIOD_M15;
   else if (clColor == ColorM30) nPeriod = PERIOD_M30;
   else if (clColor == ColorH1) nPeriod = PERIOD_H1;
   else if (clColor == ColorH2) nPeriod = 120;
   else if (clColor == ColorH4) nPeriod = PERIOD_H4;
   else if (clColor == ColorH8) nPeriod = 480;
   else if (clColor == ColorD1) nPeriod = PERIOD_D1;
   else if (clColor == ColorD2) nPeriod = 2880;
   else if (clColor == ColorW1) nPeriod = PERIOD_W1;
   else if (clColor == ColorW2) nPeriod = 20160;
   else if (clColor == ColorMN1) nPeriod = PERIOD_MN1;
   else if (clColor == ColorMN2) nPeriod = 86400;
   else 
      nPeriod = 0;

   return (nPeriod);
}
//+------------------------------------------------------------------+

color GetColorByTF(int nTimeFrame)
{
   color clResult;
   
   switch(nTimeFrame)
   {
      case PERIOD_M1: clResult = ColorM1; break;
      case 2: clResult = ColorM2; break;
      case PERIOD_M5: clResult = ColorM5; break;
      case 10: clResult = ColorM10; break;
      case PERIOD_M15: clResult = ColorM15; break;
      case PERIOD_M30: clResult = ColorM30; break;
      case PERIOD_H1: clResult = ColorH1; break;
      case 120: clResult = ColorH2; break;
      case PERIOD_H4: clResult = ColorH4; break;
      case 480: clResult = ColorH8; break;
      case PERIOD_D1: clResult = ColorD1; break;
      case 2880: clResult = ColorD2; break;
      case PERIOD_W1: clResult = ColorW1; break;
      case 20160: clResult = ColorW2; break;
      case PERIOD_MN1: clResult = ColorMN1; break;
      case 86400: clResult = ColorMN2; break;
      default: clResult = ColorM1; break;
   }

   return (clResult);
}

string GetTFName(int nTimeFrame)
{
   string sName = "";
   
   switch(nTimeFrame)
   {
      case PERIOD_M1: sName = "M1"; break;
      case 2: sName = "M2"; break;
      case PERIOD_M5: sName = "M5"; break;
      case 10: sName = "M10"; break;
      case PERIOD_M15: sName = "M15"; break;
      case PERIOD_M30: sName = "M30"; break;
      case PERIOD_H1: sName = "H1"; break;
      case 120: sName = "H2"; break;
      case PERIOD_H4: sName = "H4"; break;
      case 480: sName = "H8"; break;
      case PERIOD_D1: sName = "D1"; break;
      case 2880: sName = "D2"; break;
      case PERIOD_W1: sName = "W1"; break;
      case 20160: sName = "W2"; break;
      case PERIOD_MN1: sName = "MN1"; break;
      case 86400: sName = "MN2"; break;
      default: sName = ""; break;
   }

   return (sName);
}

string GetTFNameByColor(color clColor)
{
   return (GetTFName(GetTFByColor(clColor)));
}

string FindTrendLineForFiboByParams(double nFTop, double nFBottom, datetime dtFStart, datetime dtFEnd, color clTFColor, 
         bool &bUp, double &nTLPeak)
{
   string sTLName;
   datetime dtTLStart, dtTLEnd, dtCurTLStart, dtCurTLEnd, dtTemp, dtTLTop;
   double nTemp, nTLTop, nTLBottom;
   int i;
   int nObjTotal=ObjectsTotal();

   if (dtFStart > dtFEnd)
   {
      dtTemp = dtFStart;
      dtFStart = dtFEnd;
      dtFEnd = dtTemp;
   }

   for(i=0; i < nObjTotal; i++)
   {
      sTLName = ObjectName(i);
      if ( (ObjectType(sTLName) == OBJ_TREND) && (clTFColor == ObjectGet(sTLName, OBJPROP_COLOR)) && IsObjectVisible(sTLName) )
      {
         nTLTop = ObjectGet(sTLName, OBJPROP_PRICE1);
         nTLBottom = ObjectGet(sTLName, OBJPROP_PRICE2);
         
         if ( !(((nFTop == nTLTop) && (nFBottom == nTLBottom)) || ((nFTop == nTLBottom) && (nFBottom == nTLTop))) )
            continue;

         dtTLStart = ObjectGet(sTLName, OBJPROP_TIME1);
         dtTLEnd = ObjectGet(sTLName, OBJPROP_TIME2);

         PrintD(sTLName + " " + TimeToStr(dtTLStart) + " " + TimeToStr(dtTLEnd) + " | " + nTLTop + " " + nTLBottom);

         bUp = true;
         if ( ((dtTLEnd > dtTLStart) && (nTLTop > nTLBottom)) || ((dtTLEnd < dtTLStart) && (nTLTop < nTLBottom)) )
            bUp = false;
         
         if (bUp)   
            PrintD("up");
         else
            PrintD("down");
                     
         if (dtTLStart > dtTLEnd)
         {
            dtTemp = dtTLStart;
            dtTLStart = dtTLEnd;
            dtTLEnd = dtTemp;
         }
      
         if (dtTLStart >= dtFStart )
         {
            if (bUp)
            {
               if (nTLTop < nTLBottom)
                  nTLTop = nTLBottom;

               nTLPeak = nTLTop;
            }
            else
            {
               if (nTLTop < nTLBottom)
                  nTLBottom = nTLTop;
               
               nTLPeak = nTLBottom;
            }
            
            return (sTLName);
         }
      }
   }   
   
   return ("");
}

string FindTrendLineForFiboByName(string sFiboName, bool& bUp[], double& nTLPeak[])
{
   bool bTemp;
   double nTemp;
   
   string sName = FindTrendLineForFiboByParams(ObjectGet(sFiboName, OBJPROP_PRICE1), ObjectGet(sFiboName, OBJPROP_PRICE2), 
                                             ObjectGet(sFiboName, OBJPROP_TIME1), ObjectGet(sFiboName, OBJPROP_TIME2), 
                                             ObjectGet(sFiboName, OBJPROP_LEVELCOLOR), bTemp, nTemp);
 
   bUp[0] = bTemp;
   nTLPeak[0] = nTemp;
   PrintD("FindTrendLineForFiboByName UP " + bUp[0] );   
   
   return (sName);
}


string GetFiboWaveName(double nFTop, double nFBottom, datetime dtFStart, datetime dtFEnd, color clTFColor)
{
   datetime dtTLStart, dtTLEnd, dtTemp, dtTx, dturTx;
   double nTLTop, nTLBottom, nTemp, nTxPrice, nCurTxPrice;
   int n, nSpaceIndex;
   int nObjTotal=ObjectsTotal();
   string sFiboName, sTLName, sTextName, sWaveName;
   bool bUp;
   double nTLPeak;

   if (dtFStart > dtFEnd)
   {
      dtTemp = dtFStart;
      dtFStart = dtFEnd;
      dtFEnd = dtTemp;
   }

   PrintD("GetFiboWaveName Fibo " + TimeToStr(dtFStart) + " " + TimeToStr(dtFEnd) + " | " + nFTop + " " + nFBottom);

   sWaveName = "";
   //      (TrendLine)
   sTLName = FindTrendLineForFiboByParams(nFTop, nFBottom, dtFStart, dtFEnd, clTFColor, bUp, nTLPeak);
   if (sTLName != "")
   {
      dtTLStart = ObjectGet(sTLName, OBJPROP_TIME1);
      dtTLEnd = ObjectGet(sTLName, OBJPROP_TIME2);

      if (dtTLStart > dtTLEnd)
      {
         dtTemp = dtTLStart;
         dtTLStart = dtTLEnd;
         dtTLEnd = dtTemp;
      }
   
      //      
      dtTLEnd = dtTLEnd + (dtTLEnd - dtTLStart);
   
      //    -      
      if (bUp)
      {
         for(n=0; n < nObjTotal; n++)
         {
            sTextName = ObjectName(n);
         
            PrintD(sTextName + " " + ObjectType(sTextName));
            if (ObjectType(sTextName) == OBJ_TEXT)
               PrintD("Text: " + sTextName + " " + TimeToStr(ObjectGet(sTextName, OBJPROP_TIME1)) + " | " + ObjectGet(sTextName, OBJPROP_PRICE1));
            
            if ( (ObjectType(sTextName) == OBJ_TEXT) && (clTFColor == ObjectGet(sTextName, OBJPROP_COLOR)) 
                  && (ObjectGet(sTextName, OBJPROP_PRICE1) >= nTLPeak) && IsObjectVisible(sTextName) )
            {
               dturTx = ObjectGet(sTextName, OBJPROP_TIME1);
               if ( (dturTx > dtTLEnd) || (dturTx < dtTLStart) )
                  continue;
            
               nCurTxPrice = ObjectGet(sTextName, OBJPROP_PRICE1);

               if (nTxPrice == 0)
               {
                  nTxPrice = nCurTxPrice;
                  dtTx = dturTx;
                  sWaveName = ObjectDescription(sTextName);
                  PrintD("Find: " + sTextName + " " + TimeToStr(ObjectGet(sTextName, OBJPROP_TIME1)) + " | " + ObjectGet(sTextName, OBJPROP_PRICE1));
               }
               else
               {
                  if (nCurTxPrice < nTxPrice)
                  {
                     nTxPrice = nCurTxPrice;
                     dtTx = dturTx;
                     sWaveName = ObjectDescription(sTextName);
                     PrintD("Find: " + sTextName + " " + TimeToStr(ObjectGet(sTextName, OBJPROP_TIME1)) + " | " + ObjectGet(sTextName, OBJPROP_PRICE1));
                  }
               }
            }
         }
      }
      else
      {
         //     
         for(n=0; n < nObjTotal; n++)
         {
            sTextName = ObjectName(n);
         
            PrintD(sTextName + " " + ObjectType(sTextName));
            if (ObjectType(sTextName) == OBJ_TEXT)
               PrintD("Text: " + sTextName + " " + TimeToStr(ObjectGet(sTextName, OBJPROP_TIME1)) + " | " + ObjectGet(sTextName, OBJPROP_PRICE1));
            
            if ( (ObjectType(sTextName) == OBJ_TEXT) && (clTFColor == ObjectGet(sTextName, OBJPROP_COLOR)) 
                  && (ObjectGet(sTextName, OBJPROP_PRICE1) <= nTLPeak) && IsObjectVisible(sTextName) )
            {
               dturTx = ObjectGet(sTextName, OBJPROP_TIME1);
               if ( (dturTx > dtTLEnd) || (dturTx < dtTLStart) )
                  continue;
            
               nCurTxPrice = ObjectGet(sTextName, OBJPROP_PRICE1);

               if (nTxPrice == 0)
               {
                  nTxPrice = nCurTxPrice;
                  dtTx = dturTx;
                  sWaveName = ObjectDescription(sTextName);
                  PrintD("Find: " + sTextName + " " + TimeToStr(ObjectGet(sTextName, OBJPROP_TIME1)) + " | " + ObjectGet(sTextName, OBJPROP_PRICE1));
               }
               else
               {
                  if (nCurTxPrice > nTxPrice)
                  {
                     nTxPrice = nCurTxPrice;
                     dtTx = dturTx;
                     sWaveName = ObjectDescription(sTextName);
                     PrintD("Find: " + sTextName + " " + TimeToStr(ObjectGet(sTextName, OBJPROP_TIME1)) + " | " + ObjectGet(sTextName, OBJPROP_PRICE1));
                  }
               }
            }
         }
      }
   }
   
   //     TF,    (    )
   nSpaceIndex = StringFind(sWaveName, " ", 1);
   if (nSpaceIndex > 0)
      sWaveName = StringSubstr(sWaveName, 0, nSpaceIndex);
   
   return (sWaveName);
}

void RenameOldObjects()
{
   int obj_total=ObjectsTotal();
   int i, j, num, nSpaceIndex, nWindow, err;
   string name, sNewName, sTypeName;
   int nObjType;
   datetime dObjTime;
   string arObjectsToDelete[];
   
   int nObjectsToDeleteCount = 0;
   ArrayResize( arObjectsToDelete, obj_total );
   
   for(i=0; i < obj_total; i++)
   {
      name = ObjectName(i);
      nObjType = ObjectType(name);

      if (!(nObjType == OBJ_TREND || nObjType == OBJ_TEXT || nObjType == OBJ_FIBO || nObjType == OBJ_ARROW))
         continue;

      //if (nObjType == OBJ_ARROW)
      //{
      //   if (ObjectGet(name, OBJPROP_ARROWCODE) != SYMBOL_RIGHTPRICE)
      //      continue;
      //}

      nSpaceIndex = StringFind(name, " ", 1);
      if (nSpaceIndex > -1)
      {
         sTypeName = StringSubstr(name, 0, nSpaceIndex);
         
         if ( (nObjType == OBJ_TREND && sTypeName == "Trendline") || 
              (nObjType == OBJ_FIBO && sTypeName == "Fibo") || 
              (nObjType == OBJ_TEXT && sTypeName == "Text") ||
              (nObjType == OBJ_ARROW && sTypeName == "Arrow") )
         {
            num = StrToInteger(StringSubstr(name, nSpaceIndex + 1, StringLen(name) - nSpaceIndex));

            if (num != 0)
            {
               arObjectsToDelete[nObjectsToDeleteCount] = name;
               //Print(nObjectsToDeleteCount + " " + arObjectsToDelete[nObjectsToDeleteCount] + " " + name + "|" + sTypeName + "|" + StringSubstr(name, nSpaceIndex + 1, StringLen(name) - nSpaceIndex) + "|" + num);
               nObjectsToDeleteCount++;
            }
         }
      }
   }     


   for(i=0; i < nObjectsToDeleteCount; i++)
   {
      name = arObjectsToDelete[i];
      nObjType = ObjectType(name);
      nWindow = ObjectFind(name);
   
      nSpaceIndex = StringFind(name, " ", 1);
      if (nSpaceIndex == -1)
      {
         Print("ERROR!!!!!!!!!!!!!");
         continue;
      }
         
      sTypeName = StringSubstr(name, 0, nSpaceIndex);
      num = StrToInteger(StringSubstr(name, nSpaceIndex + 1, StringLen(name) - nSpaceIndex));
      sNewName = sTypeName + " _" + num;
      
      //Print(name + " " + sNewName + " " + sTypeName + " " + nWindow);
      
      if (nObjType == OBJ_TREND)
      {
         if (ObjectCreate( sNewName, OBJ_TREND, nWindow, ObjectGet(name, OBJPROP_TIME1), ObjectGet(name, OBJPROP_PRICE1), ObjectGet(name, OBJPROP_TIME2), ObjectGet(name, OBJPROP_PRICE2) ) )
         {
            ObjectSet( sNewName, OBJPROP_COLOR, ObjectGet(name, OBJPROP_COLOR) );
            ObjectSet( sNewName, OBJPROP_RAY	 , ObjectGet(name, OBJPROP_RAY) );
            ObjectSet( sNewName, OBJPROP_STYLE, ObjectGet(name, OBJPROP_STYLE) );
            ObjectSet( sNewName, OBJPROP_WIDTH, ObjectGet(name, OBJPROP_WIDTH) );
            ObjectSet( sNewName, OBJPROP_BACK, ObjectGet(name, OBJPROP_BACK) );
            ObjectSet( sNewName, OBJPROP_TIMEFRAMES, ObjectGet(name, OBJPROP_TIMEFRAMES) );
         }
         else
         {
            err=GetLastError();
            Print("error(",err,"): ", ErrorDescription(err));
         }
      }
      else if (nObjType == OBJ_TEXT)
      {
         if (ObjectCreate( sNewName, OBJ_TEXT, nWindow, ObjectGet(name, OBJPROP_TIME1), ObjectGet(name, OBJPROP_PRICE1) ) )
         {
            ObjectSetText ( sNewName, ObjectDescription(name), ObjectGet(name, OBJPROP_FONTSIZE) );
            ObjectSet	( sNewName, OBJPROP_COLOR, ObjectGet(name, OBJPROP_COLOR) );
            ObjectSet	( sNewName, OBJPROP_BACK, ObjectGet(name, OBJPROP_BACK) );
            ObjectSet	( sNewName, OBJPROP_TIMEFRAMES, ObjectGet(name, OBJPROP_TIMEFRAMES) );
         }
         else
         {
            err=GetLastError();
            Print("error(",err,"): ",ErrorDescription(err));
         }
      }
      else if (nObjType == OBJ_ARROW)
      {
         if (ObjectCreate( sNewName, OBJ_ARROW, nWindow, ObjectGet(name, OBJPROP_TIME1), ObjectGet(name, OBJPROP_PRICE1) ) )
         {
            ObjectSet(sNewName, OBJPROP_ARROWCODE, ObjectGet(name, OBJPROP_ARROWCODE));
            ObjectSet( sNewName, OBJPROP_COLOR, ObjectGet(name, OBJPROP_COLOR) );
            ObjectSet( sNewName, OBJPROP_BACK, ObjectGet(name, OBJPROP_BACK) );
            ObjectSet( sNewName, OBJPROP_TIMEFRAMES, ObjectGet(name, OBJPROP_TIMEFRAMES) );
         }
         else
         {
            err=GetLastError();
            Print("error(",err,"): ",ErrorDescription(err));
         }
      }
      else if (nObjType == OBJ_FIBO)
      {
         if (ObjectCreate(sNewName, OBJ_FIBO, nWindow, ObjectGet(name, OBJPROP_TIME1), ObjectGet(name, OBJPROP_PRICE1), ObjectGet(name, OBJPROP_TIME2), ObjectGet(name, OBJPROP_PRICE2) ) )
         {
            ObjectSet	( sNewName, OBJPROP_COLOR, ObjectGet(name, OBJPROP_COLOR) );
            ObjectSet	( sNewName, OBJPROP_LEVELCOLOR, ObjectGet(name, OBJPROP_LEVELCOLOR) );
            ObjectSet	( sNewName, OBJPROP_LEVELSTYLE, ObjectGet(name, OBJPROP_LEVELSTYLE) );
            ObjectSet	( sNewName, OBJPROP_LEVELWIDTH, ObjectGet(name, OBJPROP_LEVELWIDTH) );
            ObjectSet	( sNewName, OBJPROP_STYLE, ObjectGet(name, OBJPROP_STYLE) );
            ObjectSet	( sNewName, OBJPROP_WIDTH, ObjectGet(name, OBJPROP_WIDTH) );
            ObjectSet	( sNewName, OBJPROP_BACK, ObjectGet(name, OBJPROP_BACK) );
            ObjectSet	( sNewName, OBJPROP_RAY, ObjectGet(name, OBJPROP_RAY) );
            ObjectSet	( sNewName, OBJPROP_FIBOLEVELS, ObjectGet(name, OBJPROP_FIBOLEVELS) );
            ObjectSet	( sNewName, OBJPROP_TIMEFRAMES, ObjectGet(name, OBJPROP_TIMEFRAMES) );
            
            for(j=0; j < ObjectGet(name, OBJPROP_FIBOLEVELS); j++)
            {
               ObjectSet(sNewName, OBJPROP_FIRSTLEVEL + j, ObjectGet(name, OBJPROP_FIRSTLEVEL + j));
               ObjectSetFiboDescription(sNewName, j, ObjectGetFiboDescription( name, j) );
            }
         }
         else
         {
            err=GetLastError();
            Print("error(",err,"): ",ErrorDescription(err));
         }
      }
   
      ObjectDelete(name);
   }
}

